#include <stdio.h>
#include <stdlib.h>
#include "algoreco.h"

/* #define debug */
/* #define from_encoding dos */
/* #define to_encoding dos */
#define message_encoding dos
#define max_buffer_size 512

int from_encoding=dos;
int to_encoding=dos;
unsigned char buffer[max_buffer_size],debugchar[2];
unsigned int lastchar, newchar, j, n, code_num;
int i, statist[5];


#define from_to_char(argf,argt,argd) \
                ( argd < 128 )? argd :\
                (( argf ==iso)&&( argt ==iso))?  argd :\
                ( argf ==iso)? to_the [ argt ][ argd & 127 ] :\
                ( argt ==iso)? from_the [ argf ][ argd & 127 ] :\
         to_the [ argt ][(from_the [ argf ][ argd & 127]) & 127 ]

#define from_char(argf,argd) ((argd<128)||(argf==iso))? argd :\
                             from_the [argf][argd & 127]

void scode(int ncode)
{
  switch(ncode) {
    case win: fputs("CP1251",stderr); break;
    case dos: fputs("CP866",stderr); break;
    case koi: fputs("KOI8",stderr); break;
    case mac: fputs("MacOS",stderr); break;
    case iso: fputs("ISO8859-5",stderr);
  }
}

int biletter_index (int encoding, int last_char, int new_char)
{
   int new;
   new=key_new[from_char(encoding,new_char)];
   new=(table[key_last[from_char(encoding,last_char)]][new>>2]>>((new & 3)<<1))&3;
   if (new==3) new=-10;
   return(new);
}

void info(void)
{
  fputs("Usage: recode [-D/-W/-I/-K/-M] [-d/-w/-i/-k/-m] [-q] input_file [output_file]\n",stderr);
  fputs("  -D/-W/-I/-K/-M  - from CP866 (DOS) / CP1251 (WIN) / ISO8859-5 / KOI8 / MacOS\n",stderr);
  fputs("  -d/-w/-i/-k/-m  - to CP866 (DOS) / CP1251 (WIN) / ISO8859-5 / KOI8 / MacOS\n",stderr);
  fputs("         default  : from=to[=CP866], output_file=stdout\n",stderr);
  fputs("              -q  - ignore defaults\n",stderr);
  exit(0);
}

void ignore(char c)
{
  fprintf(stderr,"key -%c ignored\n",c);
}

void signore(char *s)
{
  fprintf(stderr,"word \"%s\" ignored\n",s);
}

void fignore(char *s)
{
  fprintf(stderr,"can not open file \"%s\"\n",s);
  exit(0);
}

void main(int argc, char **argv)
{
  FILE *fdat,*fres;
  int From,To,Ignore;
  fdat=NULL; fres=stdout;
  From=0;To=0;Ignore=0;
  fputs("(C) Algorithm by S.Znamenskii, Interface by W.Zudilin, 09.04.98\n",stderr);
  for(i=1,j=0;i<argc;i++) {
    if(argv[i][0]=='-' || argv[i][0]=='/' || argv[i][0]=='\\')
    switch(argv[i][1]) {
      case 'd': if(To) ignore(argv[i][1]); else { To=1; to_encoding=dos; } break;
      case 'D': if(From) ignore(argv[i][1]); else { From=1; from_encoding=dos; } break;
      case 'w': if(To) ignore(argv[i][1]); else { To=1; to_encoding=win; } break;
      case 'W': if(From) ignore(argv[i][1]); else { From=1; from_encoding=win; } break;
      case 'i': if(To) ignore(argv[i][1]); else { To=1; to_encoding=iso; } break;
      case 'I': if(From) ignore(argv[i][1]); else { From=1; from_encoding=iso; } break;
      case 'k': if(To) ignore(argv[i][1]); else { To=1; to_encoding=koi; } break;
      case 'K': if(From) ignore(argv[i][1]); else { From=1; from_encoding=koi; } break;
      case 'm': if(To) ignore(argv[i][1]); else { To=1; to_encoding=mac; } break;
      case 'M': if(From) ignore(argv[i][1]); else { From=1; from_encoding=mac; } break;
      case 'q': case 'Q': Ignore=1; break;
      default: info();
    }
    else if(!fdat) {
      if(!(fdat=freopen(argv[i],"r",stdin))) fignore(argv[i]);
    }
    else if(fres==stdout) {
      if(!(fres=freopen(argv[i],"w",stdout))) fignore(argv[i]);
    }
    else signore(argv[i]);
  }
  if(!fdat) { fprintf(stderr,"no input file\n"); info(); }
  if(To==1 && From==0) from_encoding=to_encoding;
  else if(To==0 && From==1) to_encoding=from_encoding;

  while (((newchar=getchar())!=EOF)&&( newchar<128))
  {
    putchar(newchar);
    lastchar=newchar;
  }
  n=0;
        j=0;
  /* ய⨢  ⨭᪮ 砫 */
  while ((n<max_buffer_size)&&(newchar!=EOF))
  {
    /* ஢塞  ஢ from_encoding 室 ⥪, ࠭ 
     * 直 砩   
     */
    buffer[n++]=newchar;
    i=biletter_index(from_encoding,lastchar,newchar);
#ifdef debug
                debugchar[0]=from_to_char(from_encoding,message_encoding,lastchar);
                debugchar[1]=from_to_char(from_encoding,message_encoding,newchar);
                fprintf(stderr,"\n%.1s%d%.1s{[%d,%d]->[%d,%d]->[%d,%d]->%d>>%d(%d)}",
                debugchar, i,debugchar+1,
                lastchar,newchar,
                from_char(from_encoding,lastchar), from_char(from_encoding,newchar),
                key_last[from_char(from_encoding,lastchar)],
                key_new[from_char(from_encoding,newchar)],
                table[key_last[from_char(from_encoding,lastchar)]]
                [key_new[from_char(from_encoding,newchar)]>>2],
                (key_new[from_char(from_encoding,newchar)]&3)<<1,
                from_encoding);
#endif
    if (newchar>128)
    {
      j=(i==0)? j+2:
        (i==1)? j++:
        (i==2)? 0:5;
      if (j>3)
      {
#ifdef debug
        fprintf(stderr,"\n⥫쭮 宦  ᫨!");
#endif
        break;
      }
    }
    lastchar=newchar;
    newchar=getchar();
  }
    /* ᫨  ᮡ ᭮ ᮬ   - 稢;
     *
     */
  if ((n==max_buffer_size)||(newchar==EOF) || Ignore)
    {
      scode(from_encoding);
      fputs(" --> ",stderr);
      scode(to_encoding);
      fputc('\n',stderr);
      for(i=0;i<n;i++)
      {
        putchar( from_to_char ( from_encoding, to_encoding, (buffer[i]) ) );
      }
      while ((newchar)!=EOF)
      {
        putchar( from_to_char ( from_encoding, to_encoding, newchar ) );
        newchar=getchar();
      }
      exit (0);
    }
    /* ᫨  ᮬ, 塞 ࠢ ஢;
     * 砫 塞 ਠ  ⨪.
     */
    while ((n!=max_buffer_size)&&((newchar=getchar())!=EOF))
    {
      buffer[n++]=newchar;
    }
    lastchar=' ';
    for(j=0;j<5;j++)
    {
#ifdef debug
      fprintf(stderr,"\nࠥ ⨪  ஢  %d:",j);
#endif
      statist[j]=0;
      lastchar=' ';
      for (i=0;i<n;i++)
      {
#ifdef debug
        char debg[2]="  ";
        int q,r,b;
#endif
        newchar=buffer[i];
        statist[j]+=
                biletter_index(j,lastchar,newchar);
#ifdef debug
                debg[0]=from_to_char(j, message_encoding, lastchar);
                fprintf(stderr,"%.1s", debg);
                if(biletter_index(j,lastchar,newchar))
                fprintf(stderr,"%d", biletter_index(j,lastchar,newchar));
#endif
        lastchar=newchar;
      }
#ifdef debug
    fprintf(stderr,"\n ஢ %d ࠢ %d.",j,statist[j]);
#endif
    }
    /* ⠫ । ⥫
     */
    code_num=from_encoding;
                for(i=0;i<5;i++)
                {
      if (statist[i] > statist[code_num]) code_num=i;
                }
#ifdef debug
     fprintf(stderr,"\n஢ 䠩= %d.",code_num);
#endif
    scode(code_num);
    fputs(" --> ",stderr);
    scode(to_encoding);
    fputc('\n',stderr);
    /*   ࠡ
     */
    for(i=0;i<n;i++)
    {
      putchar( from_to_char ( code_num, to_encoding, (buffer[i]) ) );
    }
    while ((newchar=getchar())!=EOF)
    {
      putchar(from_to_char(code_num, to_encoding, newchar));
    }
}


